#!/usr/bin/perl

# This example shows how to initialize on optical field. This script creates
# an optical field with the parameters given below. To verify the optical field
# you can either put the waist at distance z, in order to created a converging
# optical field. By propagating this field over a distance z, you should be in
# the waist of the optical beam. Alternatively, you could create the optical
# field in the waist of the optical beam and propagate, e.g., integer number
# of Rayleigh length to inspect the size of the optical field at these distances.
#
# The script also provides an example of how to retrieve data generated by 
# inline diagnostics (i.e., diagnostics performed during the optical propagation)
#
# Author:      Peter van der Slot
# Last update: 2016-08-14

my $libdir;
BEGIN {
 #find path to Physics-OPC-x.x.x/lib directory containing the OPC perl modules.
 use Cwd 'cwd';                      # to retrieve current working dir
 use File::Spec qw/splitdir catdir/; # to split or combine directory names
 #first check if environment variable is set
 $libdir = File::Spec->catdir($ENV{OPC_HOME}, 'lib');
 unless (-d $libdir) {
   #not found, now check in path to directory from which script is run 
   my @mydirs =  File::Spec->splitdir( Cwd->cwd() );
   while (@mydirs) {
     $libdir = File::Spec->catdir (@mydirs, $OPC_VERSiON, 'lib');
     last if -d $libdir;
     pop @mydirs;
   }
 }
}

use lib "$libdir";
use Physics::OPC;
use strict;

$VERBOSE = 0;

my $npoints = 251;         # number of grid points (square grid)
my $nslices = 800;			   # number of slices
my $dgrid = 4.5e-3;        # size of grid

my $cl = 299792458;        # speed of light in vacuum
my $wavelength = 1e-6;     # radiation wavelength

my $mesh = 2*$dgrid/($npoints-1);  # recalculate distance between meshpoints

my $w0 = 1.0e-3;
my $z= 2.0 * 3.141593 * $w0*$w0 / $wavelength;

$field = field
	mode_type => 'hermite',
	mx => 1,
	my => 1,
	p0 => 1.0e4,
	w0 => $w0,
	z0 => $z,
	tprofile => 'parabolic',
	trms => 1.2e-13,
	rad_offset => 0.0e-12,
	lambda => $wavelength,
	npoints => $npoints,
	mesh => $mesh,
	nslices => $nslices;

$USE_MPI{optics} ="mpiexec -n 4";

# in the following we propagate the optical pulse and request
# diagnostic information. At the end of the propagation (after
# 5 m), we determine the statistical properties and want to use
# the data in this script as well as store it to file. Note
# that the '>' in front of the filename means that the file is 
# overwritten each time this script is run. Use '>>' to append.
# We also request the total power in each slice at this position 
# and want to have it available as well in this script. 

my %stat1 = statistics $field;

my $optics = optics "
            fresnel z=$z M=1.0
            stat var=stat1 filename='>stat_end.txt'
            total var=tot1
          ";

run $optics;            

# the following is an example of how to use the requested diagnostic
# data. Each data set is identified by a name that is constructed from
# the command and the name given to the var parameter. For example
# 'total var=tot1' is identified by 'total_tot1', while the dataset 
# produced by the stat command used above is identified by 'stat_stat1'.
# All data is returned in a single hash %optics_data. All data belonging
# to a certain command is stored in $optics_data{identifier}, which in itself
# is again a hash. The data is stored in the element 'data'. In general,
# the data returned is a 2-dimensional array, containing an array of data
# for each slice. The data returned for the 'stat' command is a hash.

# calculate total energy in pulse using data from the total command
my $tot=0;
foreach my $data (@{$optics_data{total_tot1}{data}}) { # loop over slices
  $tot += $_ for @{$data};                          # loop over data returned for each slice
} 
$tot *= $wavelength/$cl;  # convert to energy
print "\n\nTotal energy = $tot J\n";

# example of how to address a single data point (slice 400). Since the total
# command returns a single element per slice (the power in each slice) we 
# only have a single array element (index of array elements starts at 0)
print "\nPower in slice 200 = $optics_data{total_tot1}{data}[200][0] W\n";

print "\nInitial values ...\n\n";
foreach my $key (sort {lc $a cmp lc $b} keys %stat1) {
	print "$key : $stat1{$key}\n" if defined $stat1{$key};
}

# example of how to access and list the data returned by the 'stat' command.
print "\nValues at end of propagation ...\n\n";
for my $key (sort {lc $a cmp lc $b} keys %{$optics_data{stat_stat1}{data}}) {
  print "$key = $optics_data{stat_stat1}{data}{$key}\n" if defined $stat1{$key};
}
  


